/**
 * Logging support.
 *
 * Author: Bernhard Kauer <bk@vmmon.org>
 *
 * TU Dresden, Operating Systems Group
 *
 * Vancouver.nova is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * Vancouver.nova is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License version 2 for more details.
 */


#pragma once
#include "driver/vprintf.h"
class Logging : public Vprintf
{
  static void (*_putcf)(void *data, long int value);
  static void *_data;
 public:
  // debug functions
  static void panic(const char *format, ...) __attribute__((noreturn))  __attribute__ ((format(printf, 1, 2)));
  static void printf(const char *format, ...) __attribute__ ((format(printf, 1, 2)));
  static void init(void (*putcf)(void *, long int), void *data) { _putcf = putcf; _data = data; }
};
